
/* 	
	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/

import java.awt.*;
import java.awt.image.*;
import java.net.*;

public class springies2 extends water {

	static int CENTERX = 11;
	static int CENTERY = 12;
	static int XVEL = 13;
	static int YVEL = 14;
	static int STRENGTH = 15;
	
	double dsX, dsY;	
	int grainX, grainY;

	// /////////////////////////////////////////////// Initialization functions

	// Set up particle number "which" to be somewhere on the image,
	// with some random direction & lifespan
	void initPart(int which) {
		int c;
		double gx, gy;
		
		gx = (Math.random() * (double)imageX * imageXscale) + (double)imageXoffset;
		gy = (Math.random() * (double)imageY * imageYscale) + (double)imageYoffset;
		
		parts[which][XPOS] = gx;
		parts[which][YPOS] = gy;
		parts[which][XVEL] = Math.random()*20.0 - 10.0;
		parts[which][YVEL] = Math.random()*20.0 - 10.0;
		parts[which][STRENGTH] = Math.random()*20.0+10.0;
		parts[which][OX] = gx;
		parts[which][OY] = gy;
	
		partColors[which] = getColorC((int)gx, (int)gy);

		gx = (grainX*0.5) + ((int)(gx/grainX))*grainX;
		gy = (grainY*0.5) + ((int)(gy/grainY))*grainY;
		
		parts[which][CENTERX] = gx;
		parts[which][CENTERY] = gy;
	
	}
	
	
	void drawPart(Graphics g, int which) {
		int px,py,ox,oy,  cx, cy, b;
		
		px = ((int)parts[which][XPOS]);
		py = ((int)parts[which][YPOS]);				
		ox = ((int)parts[which][OX]);				
		oy = ((int)parts[which][OY]);				
		
		// if you draw right after jumping, you get a line
		// all the way across the screen 
			r_setColor(g, partColors[which]);
			r_drawLine(g, px,py,ox,oy); 
		
	}
		


	void initMore() {
		dsX = (double)(imageX*imageXscale);
		dsY = (double)(imageY*imageYscale);
		
		grainX = java.lang.Integer.parseInt(getParameter("grainX"));
		grainY = java.lang.Integer.parseInt(getParameter("grainY"));
		
	}


	// move the particle in the directio indicated by its DIR.
	// if it moves offscreen, move it to the other side.
	
	// hint: change this function
	void movePart(int which) {
		double rx, ry, len;
		int ix, jumped;
		
		ix = (int)(parts[which][DIR]) % 360;
		if (ix<0) ix+=360;
		// remember where you just were, so you can draw a line to it. 
		parts[which][OX] = parts[which][XPOS];
		parts[which][OY] = parts[which][YPOS];

		rx = parts[which][CENTERX] - parts[which][XPOS];
		if (rx>(dsX/2.0)) rx-=dsX;
		if (rx<(dsX/-2.0)) rx+=dsX;
		ry = parts[which][CENTERY] - parts[which][YPOS];
		if (ry>(dsY/2.0)) ry-=dsY;
		if (ry<(dsY/-2.0)) ry+=dsY;
		len = Math.sqrt(rx*rx+ry*ry);
		
		if (len>3.0) {
			parts[which][XVEL] += (parts[which][STRENGTH] * rx)/(len*len);
			parts[which][YVEL] += (parts[which][STRENGTH] * ry)/(len*len);
		}
		
		parts[which][XPOS] += 0.2 * parts[which][XVEL];
		parts[which][YPOS] += 0.2 * parts[which][YVEL];
		
		if (parts[which][XVEL]>20.0) parts[which][XVEL] *= 0.8;
		if (parts[which][XVEL]<-20.0) parts[which][XVEL] *= 0.8;
		if (parts[which][YVEL]>20.0) parts[which][YVEL] *= 0.8;
		if (parts[which][YVEL]<-20.0) parts[which][YVEL] *= 0.8;
		
		parts[which][XVEL] *= 0.999;
		parts[which][YVEL] *= 0.999;
		
		
	// set this so we don't draw a line across the whole screen
		
		
		if (Math.random()<0.003) { initPart(which); }
	}
	





}

